#region License

/*
 * Copyright 2002-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#endregion

using System;
using NUnit.Framework;

namespace Spring.Objects.Factory.Support
{
    /// <summary>
    /// </summary>
    /// <author>Erich Eichinger</author>
    [TestFixture]
    public class WebObjectUtilsTests
    {
        [Test]
        [ExpectedException(typeof(ArgumentNullException))]
        public void GetPageTypeWithNullPageName()
        {
            WebObjectUtils.GetPageType(null);
        }

        [Test]
        [ExpectedException(typeof(ArgumentNullException))]
        public void GetPageTypeWithEmptyStringPageName()
        {
            WebObjectUtils.GetPageType(string.Empty);
        }

        [Test]
        [ExpectedException(typeof(ArgumentNullException))]
        public void GetPageTypeWithWhitespacedPageName()
        {
            WebObjectUtils.GetPageType("   ");
        }

        [Test]
        [ExpectedException(typeof(ObjectCreationException))]
        public void CreatePageInstanceWhenNotRunningInServerContext()
        {
            WebObjectUtils.CreatePageInstance("foo.aspx");
        }
    }
}